﻿using System.Reflection;
using System.Windows.Controls;
using System.Windows.Media;

namespace TestProject
{
    /// <summary>
    /// 색상 리스트 박스
    /// </summary>
    public class ColorListBox : ListBox
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 선택 색상 - SelectedColor

        /// <summary>
        /// 선택 색상
        /// </summary>
        public Color SelectedColor
        {
            set
            {
                SelectedValue = value;
            }
            get
            {
                return (SelectedValue == null) ? Colors.Transparent : (Color)SelectedValue;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - ColorListBox()

        /// <summary>
        /// 생성자
        /// </summary>
        public ColorListBox()
        {
            PropertyInfo[] propertyInfoArray = typeof(Colors).GetProperties();

            foreach(PropertyInfo propertyInfo in propertyInfoArray)
            {
                ColorListBoxItem colorListBoxItem = new ColorListBoxItem();

                colorListBoxItem.Text  = propertyInfo.Name;
                colorListBoxItem.Color = (Color)propertyInfo.GetValue(null, null);

                Items.Add(colorListBoxItem);
            }

            SelectedValuePath = "Color";
        }

        #endregion
    }
}