﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;

namespace TestProject
{
    /// <summary>
    /// 메인 윈도우
    /// </summary>
    public class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindow()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainWindow()
        {
            Width      = 800d;
            Height     = 600d;
            FontFamily = new FontFamily("나눔고딕코딩");
            FontSize   = 16d;
            Title      = "ListBox 클래스 : 색상 리스트 박스 사용하기";

            ColorListBox colorListBox = new ColorListBox();

            colorListBox.Height = 150;
            colorListBox.Width  = 150;

            colorListBox.SelectionChanged += colorListBox_SelectionChanged;

            Content = colorListBox;

            colorListBox.SelectedIndex = 0;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 프로그램 시작하기 - Main()

        /// <summary>
        /// 프로그램 시작하기
        /// </summary>
        [STAThread]
        private static void Main()
        {
            Application application = new Application();

            application.Run(new MainWindow());
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 색상 리스트 박스 선택 변경시 처리하기 - colorListBox_SelectionChanged(sender, e)

        /// <summary>
        /// 색상 리스트 박스 선택 변경시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void colorListBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            ColorListBox colorListBox = sender as ColorListBox;

            Background = new SolidColorBrush(colorListBox.SelectedColor);
        }

        #endregion
    }
}